diff -Naur --no-dereference a/drivers/media/platform/img/vxe-vxd/encoder/topaz_api_utils.h b/drivers/media/platform/img/vxe-vxd/encoder/topaz_api_utils.h
--- a/drivers/media/platform/img/vxe-vxd/encoder/topaz_api_utils.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/media/platform/img/vxe-vxd/encoder/topaz_api_utils.h	2024-01-28 14:01:31.248353800 -0500
@@ -0,0 +1,55 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * topaz utility header
+ *
+ * Copyright (c) Imagination Technologies Ltd.
+ * Copyright (c) 2021 Texas Instruments Incorporated - http://www.ti.com/
+ *
+ * Authors:
+ *	Sunita Nadampalli <sunitan@ti.com>
+ *
+ * Re-written for upstreming
+ *	Sidraya Jayagond <sidraya.bj@pathpartnertech.com>
+ */
+
+#include <linux/types.h>
+#include "topaz_api.h"
+
+/*
+ * Calculates the correct number of macroblocks per kick and kicks per BU
+ */
+void calculate_kick_and_bu_size(unsigned int width_in_mbs,
+				unsigned int height_in_mbs,
+				unsigned char is_interlaced,
+				unsigned int max_bu_per_frame,
+				unsigned int *kick_size,
+				unsigned int *kicks_per_bu,
+				unsigned int *min_slice_height);
+
+unsigned int calculate_stride(enum img_format format,
+			      unsigned short requested_stride_bytes,
+			      unsigned short width);
+
+void topaz_setup_input_format(struct img_video_context *video,
+			      struct img_vxe_scaler_setup *scaler_setup);
+
+void topaz_setup_input_csc(struct img_video_context *video,
+			   struct img_vxe_scaler_setup *scaler_setup,
+			   struct img_vxe_csc_setup *csc_setup,
+			   enum img_csc_preset csc_preset);
+
+unsigned int topaz_get_packed_buffer_strides(unsigned short buffer_stride_bytes,
+					     enum img_format format,
+					     unsigned char enable_scaler,
+					     unsigned char is_interlaced,
+					     unsigned char is_interleaved);
+
+void prepare_mv_estimates(struct img_enc_context *enc);
+
+void adjust_pic_flags(struct img_enc_context *enc, struct img_rc_params *prc_params,
+		      unsigned char first_pic, unsigned int *flags);
+
+void setup_rc_data(struct img_video_context *video, struct pic_params *pic_params,
+		   struct img_rc_params *rc_params);
+
+void patch_hw_profile(struct img_video_params *video_params, struct img_video_context *video);
diff -Naur --no-dereference a/drivers/media/platform/img/vxe-vxd/encoder/topaz_color_formats.h b/drivers/media/platform/img/vxe-vxd/encoder/topaz_color_formats.h
--- a/drivers/media/platform/img/vxe-vxd/encoder/topaz_color_formats.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/media/platform/img/vxe-vxd/encoder/topaz_color_formats.h	2024-01-28 14:01:31.248353800 -0500
@@ -0,0 +1,97 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * buffer sizes calculation
+ *
+ * Copyright (c) Imagination Technologies Ltd.
+ * Copyright (c) 2021 Texas Instruments Incorporated - http://www.ti.com/
+ *
+ * Authors:
+ *	Sunita Nadampalli <sunitan@ti.com>
+ *
+ * Re-written for upstreming
+ *	Sidraya Jayagond <sidraya.bj@pathpartnertech.com>
+ */
+
+#include "topaz_api.h"
+#include "fw_headers/defs.h"
+
+void plane_size(enum img_format color_format, unsigned int stride,
+		unsigned int height, unsigned int *y_size, unsigned int *u_size,
+		unsigned int *v_size)
+{
+	*y_size = *u_size = *v_size = 0;
+
+	switch (color_format) {
+	case IMG_CODEC_420_PL8:
+		/* allocate frame for 4:2:0 planar format */
+		*y_size = stride * height;
+		*u_size = stride * height / 4;
+		*v_size = stride * height / 4;
+		break;
+	case IMG_CODEC_420_PL12:
+		/* allocate frame for 4:2:0 planar format (chroma interleaved) */
+		*y_size = stride * height;
+		*u_size = stride * height / 2;
+		break;
+	case IMG_CODEC_422_YUV:
+	case IMG_CODEC_422_YV12:
+	case IMG_CODEC_422_IMC2:
+		/* allocate frame for 4:2:2 format */
+		*y_size = stride * height * 2;
+		break;
+	case IMG_CODEC_422_PL8:
+		/* allocate frame for 4:2:2 planar format */
+		*y_size = stride * height;
+		*u_size = stride * height / 2;
+		*v_size = stride * height / 2;
+		break;
+	case IMG_CODEC_422_PL12:
+		/* allocate frame for 4:2:2 planar format (chroma interleaved) */
+		*y_size = stride * height;
+		*u_size = stride * height;
+		break;
+	case IMG_CODEC_Y0UY1V_8888:
+	case IMG_CODEC_UY0VY1_8888:
+	case IMG_CODEC_Y0VY1U_8888:
+	case IMG_CODEC_VY0UY1_8888:
+		/* allocate frame for 4:2:2 format */
+		*y_size = stride * height;
+		break;
+	case IMG_CODEC_444_YUV:
+	case IMG_CODEC_444_YV12:
+	case IMG_CODEC_444_IMC2:
+		/* allocate frame for 4:2:2 format */
+		*y_size = stride * height * 3;
+		break;
+	case IMG_CODEC_444_PL8:
+		/* allocate frame for 4:2:2 planar format */
+		*y_size = stride * height;
+		*u_size = stride * height;
+		*v_size = stride * height;
+		break;
+	case IMG_CODEC_444_PL12:
+		/* allocate frame for 4:2:2 planar format (chroma interleaved) */
+		*y_size = stride * height;
+		*u_size = stride * height * 2;
+		break;
+	case IMG_CODEC_ABCX:
+	case IMG_CODEC_XBCA:
+	case IMG_CODEC_ABC565:
+		/* allocate frame for RGB interleaved format */
+		*y_size = stride * height;
+		break;
+	case IMG_CODEC_420_YUV:
+	case IMG_CODEC_420_YV12:
+	case IMG_CODEC_420_IMC2:
+	case IMG_CODEC_420_PL12_PACKED:
+	case IMG_CODEC_420_PL21_PACKED:
+		/* allocate frame for 4:2:0 format */
+		*y_size = stride * height * 3 / 2;
+		break;
+	default:
+		*y_size = 0;
+		*u_size = 0;
+		*v_size = 0;
+		break;
+	}
+}
